diff --git a/enterprise/cmd/worker/internal/telemetrygatewayexporter/exporter.go b/enterprise/cmd/worker/internal/telemetrygatewayexporter/exporter.go
new file mode 100644
index 00000000000..c274ba9295c
--- /dev/null
+++ b/enterprise/cmd/worker/internal/telemetrygatewayexporter/exporter.go
@@ -0,0 +1,114 @@
+package telemetrygatewayexporter
+
+import (
+	"context"
+
+	"github.com/prometheus/client_golang/prometheus"
+	"github.com/prometheus/client_golang/prometheus/promauto"
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/internal/conf"
+	"github.com/sourcegraph/sourcegraph/internal/database"
+	"github.com/sourcegraph/sourcegraph/internal/goroutine"
+	"github.com/sourcegraph/sourcegraph/internal/metrics"
+	"github.com/sourcegraph/sourcegraph/internal/observation"
+	"github.com/sourcegraph/sourcegraph/internal/telemetrygateway"
+	"github.com/sourcegraph/sourcegraph/internal/trace"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type exporterJob struct {
+	logger       log.Logger
+	store        database.TelemetryEventsExportQueueStore
+	exporter     telemetrygateway.Exporter
+	maxBatchSize int
+
+	// batchSizeHistogram records real batch sizes of each export.
+	batchSizeHistogram prometheus.Histogram
+	// exportedEventsCounter records successfully exported events.
+	exportedEventsCounter prometheus.Counter
+}
+
+func newExporterJob(
+	obctx *observation.Context,
+	store database.TelemetryEventsExportQueueStore,
+	exporter telemetrygateway.Exporter,
+	cfg config,
+) goroutine.BackgroundRoutine {
+	job := &exporterJob{
+		logger:       obctx.Logger,
+		store:        store,
+		maxBatchSize: cfg.MaxExportBatchSize,
+		exporter:     exporter,
+
+		batchSizeHistogram: promauto.NewHistogram(prometheus.HistogramOpts{
+			Namespace: "src",
+			Subsystem: "telemetrygatewayexport",
+			Name:      "batch_size",
+			Help:      "Size of event batches exported from the queue.",
+		}),
+		exportedEventsCounter: promauto.NewCounter(prometheus.CounterOpts{
+			Namespace: "src",
+			Subsystem: "telemetrygatewayexport",
+			Name:      "exported_events",
+			Help:      "Number of events exported from the queue.",
+		}),
+	}
+	return goroutine.NewPeriodicGoroutine(
+		context.Background(),
+		job,
+		goroutine.WithName("telemetrygatewayexporter.exporter"),
+		goroutine.WithDescription("telemetrygatewayexporter events export job"),
+		goroutine.WithInterval(cfg.ExportInterval),
+		goroutine.WithOperation(obctx.Operation(observation.Op{
+			Name:    "TelemetryGateway.Export",
+			Metrics: metrics.NewREDMetrics(prometheus.DefaultRegisterer, "telemetrygatewayexporter_exporter"),
+		})),
+	)
+}
+
+var _ goroutine.Finalizer = (*exporterJob)(nil)
+
+func (j *exporterJob) OnShutdown() { _ = j.exporter.Close() }
+
+func (j *exporterJob) Handle(ctx context.Context) error {
+	logger := trace.Logger(ctx, j.logger).
+		With(log.Int("maxBatchSize", j.maxBatchSize))
+
+	if conf.Get().LicenseKey == "" {
+		logger.Debug("license key not set, skipping export")
+		return nil
+	}
+
+	// Get events from the queue
+	batch, err := j.store.ListForExport(ctx, j.maxBatchSize)
+	if err != nil {
+		return errors.Wrap(err, "ListForExport")
+	}
+	j.batchSizeHistogram.Observe(float64(len(batch)))
+	if len(batch) == 0 {
+		logger.Debug("no events to export")
+		return nil
+	}
+
+	logger.Info("exporting events", log.Int("count", len(batch)))
+
+	// Send out events
+	succeeded, exportErr := j.exporter.ExportEvents(ctx, batch)
+
+	// Mark succeeded events
+	j.exportedEventsCounter.Add(float64(len(succeeded)))
+	if err := j.store.MarkAsExported(ctx, succeeded); err != nil {
+		logger.Error("failed to mark exported events as exported",
+			log.Strings("succeeded", succeeded),
+			log.Error(err))
+	}
+
+	// Report export status
+	if exportErr != nil {
+		return exportErr
+	}
+
+	logger.Info("events exported", log.Int("succeeded", len(succeeded)))
+	return nil
+}
diff --git a/enterprise/cmd/worker/internal/telemetrygatewayexporter/queue_cleanup.go b/enterprise/cmd/worker/internal/telemetrygatewayexporter/queue_cleanup.go
new file mode 100644
index 00000000000..38908b18008
--- /dev/null
+++ b/enterprise/cmd/worker/internal/telemetrygatewayexporter/queue_cleanup.go
@@ -0,0 +1,50 @@
+package telemetrygatewayexporter
+
+import (
+	"context"
+	"time"
+
+	"github.com/prometheus/client_golang/prometheus"
+	"github.com/prometheus/client_golang/prometheus/promauto"
+
+	"github.com/sourcegraph/sourcegraph/internal/database"
+	"github.com/sourcegraph/sourcegraph/internal/goroutine"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type queueCleanupJob struct {
+	store database.TelemetryEventsExportQueueStore
+
+	retentionWindow time.Duration
+
+	prunedHistogram prometheus.Histogram
+}
+
+func newQueueCleanupJob(store database.TelemetryEventsExportQueueStore, cfg config) goroutine.BackgroundRoutine {
+	job := &queueCleanupJob{
+		store: store,
+		prunedHistogram: promauto.NewHistogram(prometheus.HistogramOpts{
+			Namespace: "src",
+			Subsystem: "telemetrygatewayexport",
+			Name:      "pruned",
+			Help:      "Size of exported events pruned from the queue table.",
+		}),
+	}
+	return goroutine.NewPeriodicGoroutine(
+		context.Background(),
+		job,
+		goroutine.WithName("telemetrygatewayexporter.queue_cleanup"),
+		goroutine.WithDescription("telemetrygatewayexporter queue cleanup"),
+		goroutine.WithInterval(cfg.QueueCleanupInterval),
+	)
+}
+
+func (j *queueCleanupJob) Handle(ctx context.Context) error {
+	count, err := j.store.DeletedExported(ctx, time.Now().Add(-j.retentionWindow))
+	if err != nil {
+		return errors.Wrap(err, "store.DeletedExported")
+	}
+	j.prunedHistogram.Observe(float64(count))
+
+	return nil
+}
diff --git a/enterprise/cmd/worker/internal/telemetrygatewayexporter/telemetrygatewayexporter.go b/enterprise/cmd/worker/internal/telemetrygatewayexporter/telemetrygatewayexporter.go
new file mode 100644
index 00000000000..06476bcd504
--- /dev/null
+++ b/enterprise/cmd/worker/internal/telemetrygatewayexporter/telemetrygatewayexporter.go
@@ -0,0 +1,100 @@
+package telemetrygatewayexporter
+
+import (
+	"context"
+	"time"
+
+	"github.com/sourcegraph/log"
+
+	workerdb "github.com/sourcegraph/sourcegraph/cmd/worker/shared/init/db"
+	"github.com/sourcegraph/sourcegraph/internal/conf"
+	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/goroutine"
+	"github.com/sourcegraph/sourcegraph/internal/observation"
+	"github.com/sourcegraph/sourcegraph/internal/telemetrygateway"
+	"github.com/sourcegraph/sourcegraph/lib/errors"
+)
+
+type config struct {
+	env.BaseConfig
+
+	ExportAddress string
+
+	ExportInterval     time.Duration
+	MaxExportBatchSize int
+
+	ExportedEventsRetentionWindow time.Duration
+
+	QueueCleanupInterval time.Duration
+}
+
+var ConfigInst = &config{}
+
+func (c *config) Load() {
+	// exportAddress currently has no default value, as the feature is not enabled
+	// by default. In a future release, the default will be something like
+	// 'https://telemetry-gateway.sourcegraph.com', and eventually, won't be configurable.
+	c.ExportAddress = env.Get("TELEMETRY_GATEWAY_EXPORTER_EXPORT_ADDR", "", "Target Telemetry Gateway address")
+
+	c.ExportInterval = env.MustGetDuration("TELEMETRY_GATEWAY_EXPORTER_EXPORT_INTERVAL", 10*time.Minute,
+		"Interval at which to export telemetry")
+	c.MaxExportBatchSize = env.MustGetInt("TELEMETRY_GATEWAY_EXPORTER_EXPORT_BATCH_SIZE", 5000,
+		"Maximum number of events to export in each batch")
+
+	c.ExportedEventsRetentionWindow = env.MustGetDuration("TELEMETRY_GATEWAY_EXPORTER_EXPORTED_EVENTS_RETENTION",
+		2*24*time.Hour, "Duration to retain already-exported telemetry events before deleting")
+
+	c.QueueCleanupInterval = env.MustGetDuration("TELEMETRY_GATEWAY_EXPORTER_QUEUE_CLEANUP_INTERVAL",
+		1*time.Hour, "Interval at which to clean up telemetry export queue")
+}
+
+type telemetryGatewayExporter struct{}
+
+func NewJob() *telemetryGatewayExporter {
+	return &telemetryGatewayExporter{}
+}
+
+func (t *telemetryGatewayExporter) Description() string {
+	return "A background routine that exports telemetry events to Sourcegraph's Telemetry Gateway"
+}
+
+func (t *telemetryGatewayExporter) Config() []env.Config {
+	return []env.Config{ConfigInst}
+}
+
+func (t *telemetryGatewayExporter) Routines(initCtx context.Context, observationCtx *observation.Context) ([]goroutine.BackgroundRoutine, error) {
+	if ConfigInst.ExportAddress == "" {
+		return nil, nil
+	}
+
+	observationCtx.Logger.Info("Telemetry Gateway export enabled - initializing background routines")
+
+	db, err := workerdb.InitDB(observationCtx)
+	if err != nil {
+		return nil, err
+	}
+
+	exporter, err := telemetrygateway.NewExporter(
+		initCtx,
+		observationCtx.Logger.Scoped("exporter", "exporter client"),
+		conf.DefaultClient(),
+		ConfigInst.ExportAddress,
+	)
+	if err != nil {
+		return nil, errors.Wrap(err, "initializing export client")
+	}
+
+	observationCtx.Logger.Info("connected to Telemetry Gateway",
+		log.String("address", ConfigInst.ExportAddress))
+
+	return []goroutine.BackgroundRoutine{
+		newExporterJob(
+			observationCtx,
+			db.TelemetryEventsExportQueue(),
+			exporter,
+			*ConfigInst,
+		),
+		newQueueCleanupJob(db.TelemetryEventsExportQueue(), *ConfigInst),
+		newBacklogMetricsJob(db.TelemetryEventsExportQueue()),
+	}, nil
+}
diff --git a/enterprise/cmd/worker/shared/BUILD.bazel b/enterprise/cmd/worker/shared/BUILD.bazel
index 320a8486c99..1882ab65787 100644
--- a/enterprise/cmd/worker/shared/BUILD.bazel
+++ b/enterprise/cmd/worker/shared/BUILD.bazel
@@ -26,6 +26,7 @@ go_library(
         "//enterprise/cmd/worker/internal/permissions",
         "//enterprise/cmd/worker/internal/search",
         "//enterprise/cmd/worker/internal/telemetry",
+        "//enterprise/cmd/worker/internal/telemetrygatewayexporter",
         "//internal/auth/userpasswd",
         "//internal/authz",
         "//internal/authz/providers",
diff --git a/enterprise/cmd/worker/shared/shared.go b/enterprise/cmd/worker/shared/shared.go
index 7226276a497..4e5140e10ce 100644
--- a/enterprise/cmd/worker/shared/shared.go
+++ b/enterprise/cmd/worker/shared/shared.go
@@ -10,6 +10,7 @@ import (
 	"github.com/sourcegraph/sourcegraph/enterprise/cmd/worker/internal/githubapps"
 	"github.com/sourcegraph/sourcegraph/enterprise/cmd/worker/internal/own"
 	"github.com/sourcegraph/sourcegraph/enterprise/cmd/worker/internal/search"
+	"github.com/sourcegraph/sourcegraph/enterprise/cmd/worker/internal/telemetrygatewayexporter"
 
 	"github.com/sourcegraph/sourcegraph/cmd/frontend/globals"
 	"github.com/sourcegraph/sourcegraph/cmd/worker/job"
@@ -50,6 +51,7 @@ var additionalJobs = map[string]job.Job{
 	"permission-sync-job-cleaner":           permissions.NewPermissionSyncJobCleaner(),
 	"permission-sync-job-scheduler":         permissions.NewPermissionSyncJobScheduler(),
 	"export-usage-telemetry":                telemetry.NewTelemetryJob(),
+	"telemetrygateway-exporter":             telemetrygatewayexporter.NewJob(),
 
 	"codeintel-policies-repository-matcher":       codeintel.NewPoliciesRepositoryMatcherJob(),
 	"codeintel-autoindexing-summary-builder":      codeintel.NewAutoindexingSummaryBuilder(),
diff --git a/internal/authbearer/BUILD.bazel b/internal/authbearer/BUILD.bazel
new file mode 100644
index 00000000000..af9b48d488a
--- /dev/null
+++ b/internal/authbearer/BUILD.bazel
@@ -0,0 +1,9 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+
+go_library(
+    name = "authbearer",
+    srcs = ["authbearer.go"],
+    importpath = "github.com/sourcegraph/sourcegraph/internal/authbearer",
+    visibility = ["//:__subpackages__"],
+    deps = ["//lib/errors"],
+)
diff --git a/cmd/cody-gateway/internal/auth/bearer.go b/internal/authbearer/authbearer.go
similarity index 96%
rename from cmd/cody-gateway/internal/auth/bearer.go
rename to internal/authbearer/authbearer.go
index b1133801618..f93238c97b6 100644
--- a/cmd/cody-gateway/internal/auth/bearer.go
+++ b/internal/authbearer/authbearer.go
@@ -1,4 +1,4 @@
-package auth
+package authbearer
 
 import (
 	"net/http"
diff --git a/internal/codygateway/consts.go b/internal/codygateway/consts.go
index 329a5a23ad4..dd1083da86e 100644
--- a/internal/codygateway/consts.go
+++ b/internal/codygateway/consts.go
@@ -24,10 +24,6 @@ const (
 
 const FeatureHeaderName = "X-Sourcegraph-Feature"
 
-// GQLErrCodeProductSubscriptionNotFound is the GraphQL error code returned when
-// attempting to look up a product subscription failed by any means.
-const GQLErrCodeProductSubscriptionNotFound = "ErrProductSubscriptionNotFound"
-
 // GQLErrCodeDotcomUserNotFound is the GraphQL error code returned when
 // attempting to look up a dotcom user failed.
 const GQLErrCodeDotcomUserNotFound = "ErrDotcomUserNotFound"
diff --git a/internal/database/BUILD.bazel b/internal/database/BUILD.bazel
index 828a05d8b87..e59f2619e94 100644
--- a/internal/database/BUILD.bazel
+++ b/internal/database/BUILD.bazel
@@ -142,6 +142,7 @@ go_library(
         "//internal/rbac/types",
         "//internal/search/result",
         "//internal/security",
+        "//internal/telemetry/sensitivemetadataallowlist",
         "//internal/telemetrygateway/v1:telemetrygateway",
         "//internal/temporarysettings",
         "//internal/timeutil",
diff --git a/internal/database/telemetry_export_store.go b/internal/database/telemetry_export_store.go
index b37fc51bf6d..c08f1bc588f 100644
--- a/internal/database/telemetry_export_store.go
+++ b/internal/database/telemetry_export_store.go
@@ -13,6 +13,7 @@ import (
 	"github.com/sourcegraph/sourcegraph/internal/database/basestore"
 	"github.com/sourcegraph/sourcegraph/internal/database/batch"
 	"github.com/sourcegraph/sourcegraph/internal/featureflag"
+	"github.com/sourcegraph/sourcegraph/internal/telemetry/sensitivemetadataallowlist"
 	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
 	"github.com/sourcegraph/sourcegraph/internal/trace"
 	"github.com/sourcegraph/sourcegraph/lib/errors"
@@ -33,9 +34,8 @@ type TelemetryEventsExportQueueStore interface {
 	// ListForExport returns the cached events that should be exported next. All
 	// events returned should be exported.
 	//
-	// 🚨 SECURITY: Potentially sensitive parts of the payload are retained at
-	// this stage. The caller is responsible for ensuring sensitive data is
-	// stripped.
+	// 🚨 SECURITY: The implementation strips out sensitive contents from events
+	// that are not in sensitivemetadataallowlist.AllowedEventTypes().
 	ListForExport(ctx context.Context, limit int) ([]*telemetrygatewayv1.Event, error)
 
 	// MarkAsExported marks all events in the set of IDs as exported.
@@ -44,6 +44,9 @@ type TelemetryEventsExportQueueStore interface {
 	// DeletedExported deletes all events exported before the given timestamp,
 	// returning the number of affected events.
 	DeletedExported(ctx context.Context, before time.Time) (int64, error)
+
+	// CountUnexported returns the number of events not yet exported.
+	CountUnexported(ctx context.Context) (int64, error)
 }
 
 func TelemetryEventsExportQueueWith(logger log.Logger, other basestore.ShareableStore) TelemetryEventsExportQueueStore {
@@ -137,6 +140,8 @@ func (s *telemetryEventsExportQueueStore) ListForExport(ctx context.Context, lim
 	}
 	defer rows.Close()
 
+	sensitiveAllowlist := sensitivemetadataallowlist.AllowedEventTypes()
+
 	events := make([]*telemetrygatewayv1.Event, 0, limit)
 	for rows.Next() {
 		var id string
@@ -145,8 +150,9 @@ func (s *telemetryEventsExportQueueStore) ListForExport(ctx context.Context, lim
 		if err != nil {
 			return nil, err
 		}
-		var event telemetrygatewayv1.Event
-		if err := proto.Unmarshal(payloadPB, &event); err != nil {
+
+		event := &telemetrygatewayv1.Event{}
+		if err := proto.Unmarshal(payloadPB, event); err != nil {
 			tr.RecordError(err)
 			logger.Error("failed to unmarshal telemetry event payload",
 				log.String("id", id),
@@ -155,7 +161,11 @@ func (s *telemetryEventsExportQueueStore) ListForExport(ctx context.Context, lim
 			// investigation.
 			continue
 		}
-		events = append(events, &event)
+
+		// 🚨 SECURITY: Apply sensitive data redaction of the payload.
+		sensitiveAllowlist.Redact(event)
+
+		events = append(events, event)
 	}
 	tr.SetAttributes(attribute.Int("events", len(events)))
 	if err := rows.Err(); err != nil {
@@ -188,3 +198,12 @@ func (s *telemetryEventsExportQueueStore) DeletedExported(ctx context.Context, b
 	}
 	return result.RowsAffected()
 }
+
+func (s *telemetryEventsExportQueueStore) CountUnexported(ctx context.Context) (int64, error) {
+	var count int64
+	return count, s.ShareableStore.Handle().QueryRowContext(ctx, `
+	SELECT COUNT(*)
+	FROM telemetry_events_export_queue
+	WHERE exported_at IS NULL
+	`).Scan(&count)
+}
diff --git a/internal/database/telemetry_export_store_test.go b/internal/database/telemetry_export_store_test.go
index 0b208abfbef..8e4f347a11e 100644
--- a/internal/database/telemetry_export_store_test.go
+++ b/internal/database/telemetry_export_store_test.go
@@ -35,15 +35,17 @@ func TestTelemetryEventsExportQueueLifecycle(t *testing.T) {
 		Timestamp: timestamppb.New(time.Date(2022, 11, 3, 1, 0, 0, 0, time.UTC)),
 		Parameters: &telemetrygatewayv1.EventParameters{
 			Metadata: map[string]int64{"public": 1},
-			PrivateMetadata: &structpb.Struct{
-				Fields: map[string]*structpb.Value{"sensitive": structpb.NewStringValue("sensitive")},
-			},
 		},
 	}, {
 		Id:        "2",
 		Feature:   "Feature",
 		Action:    "Click",
 		Timestamp: timestamppb.New(time.Date(2022, 11, 3, 2, 0, 0, 0, time.UTC)),
+		Parameters: &telemetrygatewayv1.EventParameters{
+			PrivateMetadata: &structpb.Struct{
+				Fields: map[string]*structpb.Value{"sensitive": structpb.NewStringValue("sensitive")},
+			},
+		},
 	}, {
 		Id:        "3",
 		Feature:   "Feature",
@@ -63,6 +65,12 @@ func TestTelemetryEventsExportQueueLifecycle(t *testing.T) {
 		require.NoError(t, store.QueueForExport(ctx, events))
 	})
 
+	t.Run("CountUnexported", func(t *testing.T) {
+		count, err := store.CountUnexported(ctx)
+		require.NoError(t, err)
+		require.Equal(t, count, int64(3))
+	})
+
 	t.Run("ListForExport", func(t *testing.T) {
 		limit := len(events) - 1
 		export, err := store.ListForExport(ctx, limit)
@@ -74,7 +82,11 @@ func TestTelemetryEventsExportQueueLifecycle(t *testing.T) {
 		require.NoError(t, err)
 		got, err := proto.Marshal(export[0])
 		require.NoError(t, err)
-		require.Equal(t, string(original), string(got))
+		assert.Equal(t, string(original), string(got))
+
+		// Check second item's private meta is stripped
+		assert.NotNil(t, events[1].Parameters.PrivateMetadata) // original
+		assert.Nil(t, export[1].Parameters.PrivateMetadata)    // got
 	})
 
 	t.Run("before export: DeleteExported", func(t *testing.T) {
diff --git a/internal/grpc/defaults/BUILD.bazel b/internal/grpc/defaults/BUILD.bazel
index 5449e9605a9..852e0d88dbd 100644
--- a/internal/grpc/defaults/BUILD.bazel
+++ b/internal/grpc/defaults/BUILD.bazel
@@ -25,6 +25,7 @@ go_library(
         "@com_github_sourcegraph_log//:log",
         "@io_opentelemetry_go_contrib_instrumentation_google_golang_org_grpc_otelgrpc//:otelgrpc",
         "@org_golang_google_grpc//:go_default_library",
+        "@org_golang_google_grpc//credentials",
         "@org_golang_google_grpc//credentials/insecure",
         "@org_golang_google_grpc//reflection",
     ],
diff --git a/internal/grpc/defaults/defaults.go b/internal/grpc/defaults/defaults.go
index fb67842affa..c1ee943539c 100644
--- a/internal/grpc/defaults/defaults.go
+++ b/internal/grpc/defaults/defaults.go
@@ -6,18 +6,21 @@ package defaults
 
 import (
 	"context"
+	"crypto/tls"
 	"sync"
 
 	grpcprom "github.com/grpc-ecosystem/go-grpc-middleware/providers/prometheus"
 	"github.com/prometheus/client_golang/prometheus"
 	"github.com/sourcegraph/log"
-	"github.com/sourcegraph/sourcegraph/internal/grpc/contextconv"
-	"github.com/sourcegraph/sourcegraph/internal/grpc/messagesize"
 	"go.opentelemetry.io/contrib/instrumentation/google.golang.org/grpc/otelgrpc"
 	"google.golang.org/grpc"
+	"google.golang.org/grpc/credentials"
 	"google.golang.org/grpc/credentials/insecure"
 	"google.golang.org/grpc/reflection"
 
+	"github.com/sourcegraph/sourcegraph/internal/grpc/contextconv"
+	"github.com/sourcegraph/sourcegraph/internal/grpc/messagesize"
+
 	"github.com/sourcegraph/sourcegraph/internal/actor"
 	internalgrpc "github.com/sourcegraph/sourcegraph/internal/grpc"
 	"github.com/sourcegraph/sourcegraph/internal/grpc/internalerrs"
@@ -46,6 +49,23 @@ const defaultGRPCMessageReceiveSizeBytes = 90 * 1024 * 1024 // 90 MB
 // **Note**: Do not append to this slice directly, instead provide extra options
 // via "additionalOptions".
 func DialOptions(logger log.Logger, additionalOptions ...grpc.DialOption) []grpc.DialOption {
+	return defaultDialOptions(logger, insecure.NewCredentials(), additionalOptions...)
+}
+
+// ExternalDialOptions is a set of default dial options that should be used for
+// gRPC clients external to a Sourcegraph deployment, e.g. Telemetry Gateway,
+// along with any additional client-specific options. In particular, these
+// options enforce TLS.
+//
+// Traffic within a Sourcegraph deployment should use DialOptions instead.
+//
+// **Note**: Do not append to this slice directly, instead provide extra options
+// via "additionalOptions".
+func ExternalDialOptions(logger log.Logger, additionalOptions ...grpc.DialOption) []grpc.DialOption {
+	return defaultDialOptions(logger, credentials.NewTLS(&tls.Config{}), additionalOptions...)
+}
+
+func defaultDialOptions(logger log.Logger, creds credentials.TransportCredentials, additionalOptions ...grpc.DialOption) []grpc.DialOption {
 	// Generate the options dynamically rather than using a static slice
 	// because these options depend on some globals (tracer, trace sampling)
 	// that are not initialized during init time.
@@ -53,7 +73,7 @@ func DialOptions(logger log.Logger, additionalOptions ...grpc.DialOption) []grpc
 	metrics := mustGetClientMetrics()
 
 	out := []grpc.DialOption{
-		grpc.WithTransportCredentials(insecure.NewCredentials()),
+		grpc.WithTransportCredentials(creds),
 		grpc.WithChainStreamInterceptor(
 			metrics.StreamClientInterceptor(),
 			messagesize.StreamClientInterceptor,
diff --git a/internal/productsubscription/consts.go b/internal/productsubscription/consts.go
index a5aca29f7ed..ed1f10465de 100644
--- a/internal/productsubscription/consts.go
+++ b/internal/productsubscription/consts.go
@@ -8,3 +8,7 @@ package productsubscription
 // In the future, this prefix can be used if we ever have access tokens for
 // product subscriptions that are not based on a Sourcegraph license key.
 const AccessTokenPrefix = "sgs_" // "(S)ource(g)raph (S)ubscription"
+
+// GQLErrCodeProductSubscriptionNotFound is the GraphQL error code returned when
+// attempting to look up a product subscription failed by any means.
+const GQLErrCodeProductSubscriptionNotFound = "ErrProductSubscriptionNotFound"
diff --git a/internal/pubsub/BUILD.bazel b/internal/pubsub/BUILD.bazel
index 1e7c4affbc4..7b61c03c536 100644
--- a/internal/pubsub/BUILD.bazel
+++ b/internal/pubsub/BUILD.bazel
@@ -7,7 +7,9 @@ go_library(
     visibility = ["//:__subpackages__"],
     deps = [
         "//internal/env",
+        "//internal/trace",
         "//lib/errors",
+        "@com_github_sourcegraph_log//:log",
         "@com_google_cloud_go_pubsub//:pubsub",
         "@org_golang_google_api//option",
     ],
diff --git a/internal/pubsub/topic.go b/internal/pubsub/topic.go
index 74d0cea6716..5b1f1a4c5a6 100644
--- a/internal/pubsub/topic.go
+++ b/internal/pubsub/topic.go
@@ -7,7 +7,10 @@ import (
 	"cloud.google.com/go/pubsub"
 	"google.golang.org/api/option"
 
+	"github.com/sourcegraph/log"
+
 	"github.com/sourcegraph/sourcegraph/internal/env"
+	"github.com/sourcegraph/sourcegraph/internal/trace"
 	"github.com/sourcegraph/sourcegraph/lib/errors"
 )
 
@@ -16,6 +19,8 @@ type TopicClient interface {
 	// Ping checks if the connection to the topic is valid.
 	Ping(ctx context.Context) error
 	// Publish publishes messages and waits for all the results synchronously.
+	// It returns the first error encountered or nil if all succeeded. To collect
+	// individual errors, call Publish with only 1 message.
 	Publish(ctx context.Context, messages ...[]byte) error
 	// Stop stops the topic publishing channel. The client should not be used after
 	// calling Stop.
@@ -91,3 +96,23 @@ type noopTopicClient struct{}
 func (c *noopTopicClient) Ping(context.Context) error               { return nil }
 func (c *noopTopicClient) Publish(context.Context, ...[]byte) error { return nil }
 func (c *noopTopicClient) Stop()                                    {}
+
+// NewLoggingTopicClient creates a Pub/Sub client that just logs all messages,
+// and does nothing otherwise. This is also a useful stub implementation of the
+// TopicClient for testing/debugging purposes.
+func NewLoggingTopicClient(logger log.Logger) TopicClient {
+	return &loggingTopicClient{logger: logger.Scoped("pubsub", "")}
+}
+
+type loggingTopicClient struct {
+	logger log.Logger
+	noopTopicClient
+}
+
+func (c *loggingTopicClient) Publish(ctx context.Context, messages ...[]byte) error {
+	l := trace.Logger(ctx, c.logger)
+	for _, m := range messages {
+		l.Info("Publish", log.String("message", string(m)))
+	}
+	return nil
+}
diff --git a/internal/telemetry/BUILD.bazel b/internal/telemetry/BUILD.bazel
index 65f9a33e934..9cb50bfd8a2 100644
--- a/internal/telemetry/BUILD.bazel
+++ b/internal/telemetry/BUILD.bazel
@@ -4,6 +4,7 @@ load("//dev:go_defs.bzl", "go_test")
 go_library(
     name = "telemetry",
     srcs = [
+        "besteffort.go",
         "billing_categories.go",
         "billing_products.go",
         "events.go",
@@ -13,9 +14,10 @@ go_library(
     importpath = "github.com/sourcegraph/sourcegraph/internal/telemetry",
     visibility = ["//:__subpackages__"],
     deps = [
-        "//internal/telemetry/teestore",
         "//internal/telemetrygateway/v1:telemetrygateway",
+        "//internal/trace",
         "//internal/version",
+        "@com_github_sourcegraph_log//:log",
         "@org_golang_google_protobuf//types/known/structpb",
     ],
 )
diff --git a/internal/telemetry/besteffort.go b/internal/telemetry/besteffort.go
new file mode 100644
index 00000000000..f419066af94
--- /dev/null
+++ b/internal/telemetry/besteffort.go
@@ -0,0 +1,33 @@
+package telemetry
+
+import (
+	"context"
+
+	"github.com/sourcegraph/log"
+
+	"github.com/sourcegraph/sourcegraph/internal/trace"
+)
+
+// BestEffortEventRecorder is a version of EventRecorder that logs errors instead
+// of returning them. This is useful for non-critical telemetry collection.
+type BestEffortEventRecorder struct {
+	logger   log.Logger
+	recorder *EventRecorder
+}
+
+// NewEventRecorder creates a custom event recorder backed by a store
+// implementation. In general, prefer to use the telemetryrecorder.NewBestEffort()
+// constructor instead.
+func NewBestEffortEventRecorder(logger log.Logger, recorder *EventRecorder) *BestEffortEventRecorder {
+	return &BestEffortEventRecorder{logger: logger, recorder: recorder}
+}
+
+func (r *BestEffortEventRecorder) Record(ctx context.Context, feature eventFeature, action eventAction, parameters EventParameters) {
+	if err := r.recorder.Record(ctx, feature, action, parameters); err != nil {
+		trace.Logger(ctx, r.logger).Error("failed to record telemetry event",
+			log.String("feature", string(feature)),
+			log.String("action", string(action)),
+			log.Int("parameters.version", parameters.Version),
+			log.Error(err))
+	}
+}
diff --git a/internal/telemetry/events.go b/internal/telemetry/events.go
index fcbafb80830..c3106590baa 100644
--- a/internal/telemetry/events.go
+++ b/internal/telemetry/events.go
@@ -10,6 +10,9 @@ type eventFeature string
 // All event names in Sourcegraph's Go services.
 const (
 	FeatureExample eventFeature = "exampleFeature"
+
+	FeatureSignIn  eventFeature = "signIn"
+	FeatureSignOut eventFeature = "signOut"
 )
 
 // eventAction defines the action associated with an event. Values should
@@ -21,4 +24,8 @@ type eventAction string
 
 const (
 	ActionExample eventAction = "exampleAction"
+
+	ActionFailed    eventAction = "failed"
+	ActionSucceeded eventAction = "succeeded"
+	ActionAttempted eventAction = "attempted"
 )
diff --git a/internal/telemetry/sensitivemetadataallowlist/BUILD.bazel b/internal/telemetry/sensitivemetadataallowlist/BUILD.bazel
new file mode 100644
index 00000000000..622aa6a46f3
--- /dev/null
+++ b/internal/telemetry/sensitivemetadataallowlist/BUILD.bazel
@@ -0,0 +1,35 @@
+load("@io_bazel_rules_go//go:def.bzl", "go_library")
+load("//dev:go_defs.bzl", "go_test")
+
+go_library(
+    name = "sensitivemetadataallowlist",
+    srcs = [
+        "redact.go",
+        "sensitiviemetadataallowlist.go",
+    ],
+    importpath = "github.com/sourcegraph/sourcegraph/internal/telemetry/sensitivemetadataallowlist",
+    visibility = ["//:__subpackages__"],
+    deps = [
+        "//cmd/frontend/envvar",
+        "//internal/telemetry",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//lib/errors",
+    ],
+)
+
+go_test(
+    name = "sensitivemetadataallowlist_test",
+    srcs = [
+        "redact_test.go",
+        "sensitivemetadataallowlist_test.go",
+    ],
+    embed = [":sensitivemetadataallowlist"],
+    deps = [
+        "//internal/telemetry",
+        "//internal/telemetrygateway/v1:telemetrygateway",
+        "//lib/pointers",
+        "@com_github_stretchr_testify//assert",
+        "@com_github_stretchr_testify//require",
+        "@org_golang_google_protobuf//types/known/structpb",
+    ],
+)
diff --git a/internal/telemetry/sensitivemetadataallowlist/redact.go b/internal/telemetry/sensitivemetadataallowlist/redact.go
new file mode 100644
index 00000000000..0760ed2a65b
--- /dev/null
+++ b/internal/telemetry/sensitivemetadataallowlist/redact.go
@@ -0,0 +1,37 @@
+package sensitivemetadataallowlist
+
+import (
+	telemetrygatewayv1 "github.com/sourcegraph/sourcegraph/internal/telemetrygateway/v1"
+)
+
+// redactMode dictates how much to redact. The lowest value indicates our
+// strictest redaction mode - higher values indicate less redaction.
+type redactMode int
+
+const (
+	redactAllSensitive redactMode = iota
+	// redactMarketing only redacts marketing-related fields.
+	redactMarketing
+	// redactNothing is only used in dotocm mode.
+	redactNothing
+)
+
+// 🚨 SECURITY: Be very careful with the redaction mechanisms here, as it impacts
+// what data we export from customer Sourcegraph instances.
+func redactEvent(event *telemetrygatewayv1.Event, mode redactMode) {
+	// redactNothing
+	if mode >= redactNothing {
+		return
+	}
+
+	// redactMarketing
+	event.MarketingTracking = nil
+	if mode >= redactMarketing {
+		return
+	}
+
+	// redactAllSensitive
+	if event.Parameters != nil {
+		event.Parameters.PrivateMetadata = nil
+	}
+}
